diff -ruN freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c	Mon Feb 26 19:51:00 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c	Wed May 16 10:57:20 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipsec_tunnel_c_version[] = "RCSID $Id: ipsec_tunnel.c,v 1.137.2.1 2001/02/27 00:51:00 henry Exp $";
+char ipsec_tunnel_c_version[] = "RCSID $Id: ipsec_tunnel.c,v 1.148 2001/05/05 03:31:41 rgb Exp $";
 
 #define __NO_VERSION__
 #include <linux/module.h>
@@ -80,7 +80,7 @@
 #include <net/ip.h>
 #ifdef NETDEV_23
 #include <linux/netfilter_ipv4.h>
-#endif
+#endif /* NETDEV_23 */
 
 #include "radij.h"
 #include "ipsec_encap.h"
@@ -112,8 +112,6 @@
 #endif /* CONFIG_IPSEC_DEBUG */
 
 int sysctl_ipsec_icmp = 0;
-int sysctl_ipsec_no_eroute_pass = 0;
-int sysctl_ipsec_opportunistic = 0;
 int sysctl_ipsec_tos = 0;
 
 #ifdef CONFIG_IPSEC_DEBUG_
@@ -124,7 +122,10 @@
 	unsigned char *b = bb;
   
 	if (debug_tunnel) {
-		printk(KERN_INFO "klips_debug:ipsec_tunnel_:at %s, len=%d:", s, len);
+		printk(KERN_INFO "klips_debug:ipsec_tunnel_:dmp: "
+		       "at %s, len=%d:",
+		       s,
+		       len);
 		for (i=0; i < len; i++) {
 			if(!(i%16)){
 				printk("\nklips_debug:  ");
@@ -152,9 +153,11 @@
 	 *	Do sanity checking
 	 */
 	if((headroom < 0) || (tailroom < 0) || ((headroom+tailroom) < 0)) {
-		printk(KERN_WARNING "klips_error:skb_copy_expand: "
+		printk(KERN_WARNING
+		       "klips_error:skb_copy_expand: "
 		       "Illegal negative head,tailroom %d,%d\n",
-		       headroom, tailroom);
+		       headroom,
+		       tailroom);
 		return NULL;
 	}
 	/*
@@ -192,9 +195,9 @@
 	/* Set the tail pointer and length */
 	if(skb_tailroom(n) < skb->len) {
 		printk(KERN_WARNING "klips_error:skb_copy_expand: "
-		       "tried to skb_put %ld, %d available.  "
-		       "This should never happen, please report.\n",
-		       (unsigned long int)skb->len, skb_tailroom(n));
+		       "tried to skb_put %ld, %d available.  This should never happen, please report.\n",
+		       (unsigned long int)skb->len,
+		       skb_tailroom(n));
 		dev_kfree_skb(n, FREE_WRITE);
 		return NULL;
 	}
@@ -243,7 +246,9 @@
 	if(skb->mac.raw) 
 		n->mac.raw=skb->mac.raw+offset;
 	memcpy(n->proto_priv, skb->proto_priv, sizeof(skb->proto_priv));
+#ifndef NETDEV_23
 	n->used=skb->used;
+#endif /* !NETDEV_23 */
 	n->pkt_type=skb->pkt_type;
 	n->stamp=skb->stamp;
 	
@@ -265,11 +270,15 @@
 	printk(" ver:%d", ip->version);
 	printk(" tos:%d", ip->tos);
 	printk(" tlen:%d", ntohs(ip->tot_len));
-	printk(" id:%d", ip->id);
-	printk(" frag_off:%d", ip->frag_off);
+	printk(" id:%d", ntohs(ip->id));
+	printk(" %s%s%sfrag_off:%d",
+               ip->frag_off & __constant_htons(IP_CE) ? "CE " : "",
+               ip->frag_off & __constant_htons(IP_DF) ? "DF " : "",
+               ip->frag_off & __constant_htons(IP_MF) ? "MF " : "",
+               (ntohs(ip->frag_off) & IP_OFFSET) << 3);
 	printk(" ttl:%d", ip->ttl);
 	printk(" proto:%d", ip->protocol);
-	printk(" chk:%d", ip->check);
+	printk(" chk:%d", ntohs(ip->check));
 	addrtoa(*((struct in_addr*)(&ip->saddr)), 0, buf, sizeof(buf));
 	printk(" saddr:%s", buf);
 	addrtoa(*((struct in_addr*)(&ip->daddr)), 0, buf, sizeof(buf));
@@ -283,7 +292,8 @@
 		c = ((__u8*)ip) + ip->ihl*4;
 		for(i = 0; i < ntohs(ip->tot_len) - ip->ihl*4; i++ /*, c++*/) {
 			if(!(i % 16)) {
-				printk(KERN_INFO "klips_debug:   @%03x:",
+				printk(KERN_INFO
+				       "klips_debug:   @%03x:",
 				       i);
 			}
 			printk(" %02x", /***/c[i]);
@@ -464,6 +474,9 @@
 	struct rtable *rt = NULL;
 #endif /* NET_21 */
 	struct sa_id outgoing_said;
+#ifdef NETDEV_23
+	int pass = 0;
+#endif /* NETDEV_23 */
 
 	/*
 	 *	Return if there is nothing to do.  (Does this ever happen?) XXX
@@ -506,10 +519,17 @@
 	   tcpdump being momentarily attached to the interface), make
 	   a copy of our own to modify */
 	if(skb_cloned(skb)) {
-		if ((skb = skb_cow(skb, skb_headroom(skb))) == NULL) {
+		if
+#ifdef SKB_COW_NEW
+	       (skb_cow(skb, skb_headroom(skb)) != 0)
+#else /* SKB_COW_NEW */
+	       ((skb = skb_cow(skb, skb_headroom(skb))) == NULL)
+#endif /* SKB_COW_NEW */
+		{
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
-		        	    "klips_error:ipsec_tunnel_start_xmit: "
+				    "klips_error:ipsec_tunnel_start_xmit: "
 				    "skb_cow failed to allocate buffer, dropping.\n" );
+			stats->tx_dropped++;
 			goto cleanup;
 		}
 	}
@@ -572,8 +592,7 @@
 	if ((iph->ihl << 2) != sizeof (struct iphdr)) {
 		KLIPS_PRINT(debug_tunnel,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
-			    "cannot process IP header options yet.  "
-			    "May be mal-formed packet.\n"); /* XXX */
+			    "cannot process IP header options yet.  May be mal-formed packet.\n"); /* XXX */
 		stats->tx_dropped++;
 		goto cleanup;
 	}
@@ -636,18 +655,14 @@
 		if(iph->protocol == IPPROTO_UDP) {
 			struct udphdr *udph = (struct udphdr*)((caddr_t)iph + (iph->ihl << 2));
 			if(ntohs(udph->dest) == 500) {
+#ifdef NETDEV_23
+				pass = 1;
+#endif /* NETDEV_23 */
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
 					    "udp/500 IKE packet, sending unprocessed, "
 					    "calling dev_queue_xmit\n"); 
-#if 1
 				goto bypass;
-#else
-				DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-				/* IP_SEND(skb, physdev); */
-				skb = NULL;
-				goto cleanup;
-#endif
 			}
 		}
 	}
@@ -660,6 +675,8 @@
 	innersrc = iph->saddr;
 	/* start encapsulation loop here XXX */
 	do {
+		struct tdb *tdbprev = NULL;
+
 		newdst = orgdst = iph->daddr;
 		newsrc = orgsrc = iph->saddr;
 		orgedst = outgoing_said.dst.s_addr;
@@ -667,97 +684,187 @@
 		pyldsz = ntohs(iph->tot_len) - iphlen;
 		max_headroom = max_tailroom = 0;
 		
-		if (er == NULL)	{
-			if(sysctl_ipsec_no_eroute_pass) {
-				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
-					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "no eroute!: calling dev_queue_xmit\n");
-#if 1
-				goto bypass;
-#else
-				DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-				/* IP_SEND(skb, physdev); */
-				skb = NULL;
-#endif
-			} else {
-				if(sysctl_ipsec_opportunistic && !er) {
-					struct tdb tdb;
-					struct sockaddr_in src, dst;
-#ifdef CONFIG_IPSEC_DEBUG
-					char bufsrc[ADDRTOA_BUF], bufdst[ADDRTOA_BUF];
-#endif /* CONFIG_IPSEC_DEBUG */
-					
-					tdb.tdb_said.proto = iph->protocol;
-					src.sin_family = AF_INET;
-					dst.sin_family = AF_INET;
-					src.sin_addr.s_addr = iph->saddr;
-					dst.sin_addr.s_addr = iph->daddr;
-					src.sin_port = 
-						(iph->protocol == IPPROTO_UDP
-						 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->source
-						 : (iph->protocol == IPPROTO_TCP
-						    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->source
-						    : 0));
-					dst.sin_port = 
-						(iph->protocol == IPPROTO_UDP
-						 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->dest
-						 : (iph->protocol == IPPROTO_TCP
-						    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->dest
-						    : 0));
-					for(i = 0;
-					    i < sizeof(struct sockaddr_in)
-						    - offsetof(struct sockaddr_in, sin_zero);
-					    i++) {
-						src.sin_zero[i] = 0;
-						dst.sin_zero[i] = 0;
-					}
-					
-					tdb.tdb_addr_s = (struct sockaddr*)(&src);
-					tdb.tdb_addr_d = (struct sockaddr*)(&dst);
-					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
-						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "SADB_ACQUIRE sent with src=%s:%d, dst=%s:%d, proto=%d.\n",
-						    addrtoa(((struct sockaddr_in*)(tdb.tdb_addr_s))->sin_addr, 0, bufsrc, sizeof(bufsrc)) <= ADDRTOA_BUF ? bufsrc : "BAD_ADDR",
-						    ((struct sockaddr_in*)(tdb.tdb_addr_s))->sin_port,
-						    addrtoa(((struct sockaddr_in*)(tdb.tdb_addr_d))->sin_addr, 0, bufdst, sizeof(bufdst)) <= ADDRTOA_BUF ? bufdst : "BAD_ADDR",
-						    ((struct sockaddr_in*)(tdb.tdb_addr_d))->sin_port,
-						    tdb.tdb_said.proto);
-					pfkey_acquire(&tdb);
-				} else {
-					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
-						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "no eroute!: dropping.\n");
-					stats->tx_dropped++;
-				}
-			}
+		if(er == NULL || (outgoing_said.proto==IPPROTO_INT
+				  && outgoing_said.spi==htonl(SPI_DROP))) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "magic SA of DROP or no eroute: dropping.\n");
+			stats->tx_dropped++;
 			goto cleanup;
 		}
 		
-		/*
-		  If the packet matches an eroute with an SA.proto of IP
-		  tunnelling and 
-		  an SA.spi of '0', then forward the packet unprotected.
-		  XXX -- This should eventually go into an SPD. 
-		*/
-		if((outgoing_said.proto == IPPROTO_IPIP) && (outgoing_said.spi == 0)) {
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_REJECT)) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "magic SA of REJECT: notifying when coded... and dropping.\n");
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+		
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_PASS)) {
+#ifdef NETDEV_23
+			pass = 1;
+#endif /* NETDEV_23 */
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
-				    "passthrough eroute, packet sent.\n");
-#if 1
+				    "magic SA of PASS: calling dev_queue_xmit\n");
 			goto bypass;
-#else
-			DEV_QUEUE_XMIT(skb, physdev, SOPRI_NORMAL);
-			/* IP_SEND(skb, physdev); */
-			skb = NULL;
+		}
+
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_HOLD)) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "magic SA of HOLD: will stash when coded..., dropping for now.\n");
+			stats->tx_dropped++;
+			goto cleanup;
+		}
+		
+		if(outgoing_said.proto==IPPROTO_INT
+		   && outgoing_said.spi==htonl(SPI_TRAP)) {
+			struct tdb tdb;
+			struct sockaddr_in src, dst;
+#ifdef CONFIG_IPSEC_DEBUG
+			char bufsrc[ADDRTOA_BUF], bufdst[ADDRTOA_BUF];
+#endif /* CONFIG_IPSEC_DEBUG */
+			struct eroute hold_eroute;
+			struct sa_id hold_said;
+			int error = 0;
+			
+			/* Signal all listening KMds with a PF_KEY ACQUIRE */
+			tdb.tdb_said.proto = iph->protocol;
+			src.sin_family = AF_INET;
+			dst.sin_family = AF_INET;
+			src.sin_addr.s_addr = iph->saddr;
+			dst.sin_addr.s_addr = iph->daddr;
+			src.sin_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->source
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->source
+				    : 0));
+			dst.sin_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->dest
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->dest
+				    : 0));
+			for(i = 0;
+			    i < sizeof(struct sockaddr_in)
+				    - offsetof(struct sockaddr_in, sin_zero);
+			    i++) {
+				src.sin_zero[i] = 0;
+				dst.sin_zero[i] = 0;
+			}
+			
+			tdb.tdb_addr_s = (struct sockaddr*)(&src);
+			tdb.tdb_addr_d = (struct sockaddr*)(&dst);
+			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "SADB_ACQUIRE sent with src=%s:%d, dst=%s:%d, proto=%d.\n",
+				    addrtoa(((struct sockaddr_in*)(tdb.tdb_addr_s))->sin_addr, 0, bufsrc, sizeof(bufsrc)) <= ADDRTOA_BUF ? bufsrc : "BAD_ADDR",
+				    ((struct sockaddr_in*)(tdb.tdb_addr_s))->sin_port,
+				    addrtoa(((struct sockaddr_in*)(tdb.tdb_addr_d))->sin_addr, 0, bufdst, sizeof(bufdst)) <= ADDRTOA_BUF ? bufdst : "BAD_ADDR",
+				    ((struct sockaddr_in*)(tdb.tdb_addr_d))->sin_port,
+				    tdb.tdb_said.proto);
+			pfkey_acquire(&tdb);
+
+			/* install HOLD eroute */
+			memset((caddr_t)&hold_eroute, 0, sizeof(hold_eroute));
+			memset((caddr_t)&hold_said, 0, sizeof(hold_said));
+
+			hold_said.proto = IPPROTO_INT;
+			hold_said.spi = htonl(SPI_HOLD);
+			hold_said.dst.s_addr = 0L;
+
+			hold_eroute.er_eaddr.sen_len = sizeof(struct sockaddr_encap);
+			hold_eroute.er_emask.sen_len = sizeof(struct sockaddr_encap);
+			hold_eroute.er_eaddr.sen_family = AF_ENCAP;
+			hold_eroute.er_emask.sen_family = AF_ENCAP;
+			hold_eroute.er_eaddr.sen_type = SENT_IP4;
+			hold_eroute.er_emask.sen_type = 255;
+
+			hold_eroute.er_eaddr.sen_ip_src.s_addr = iph->saddr;
+			hold_eroute.er_eaddr.sen_ip_dst.s_addr = iph->daddr;
+			hold_eroute.er_emask.sen_ip_src.s_addr = INADDR_BROADCAST;
+			hold_eroute.er_emask.sen_ip_dst.s_addr = INADDR_BROADCAST;
+			
+#ifdef IPSEC_CONFIG_FULL_SELECTOR_LIST
+			/* These are ficticious.  Don't uncomment these until
+			   proto, sport and dport exist in the SPDB */
+			hold_eroute.er_proto = iph->protocol;
+			hold_eroute.er_src_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->source
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->source
+				    : 0));
+			hold_eroute.er_dst_port = 
+				(iph->protocol == IPPROTO_UDP
+				 ? ((struct udphdr*) (((caddr_t)iph) + (iph->ihl << 2)))->dest
+				 : (iph->protocol == IPPROTO_TCP
+				    ? ((struct tcphdr*)((caddr_t)iph + (iph->ihl << 2)))->dest
+				    : 0));
+#endif /* IPSEC_CONFIG_FULL_SELECTOR_LIST */
+
+#ifdef CONFIG_IPSEC_DEBUG
+			if (debug_pfkey) {
+				char buf1[64], buf2[64];
+				subnettoa(hold_eroute.er_eaddr.sen_ip_src,
+					  hold_eroute.er_emask.sen_ip_src, 0, buf1, sizeof(buf1));
+				subnettoa(hold_eroute.er_eaddr.sen_ip_dst,
+					  hold_eroute.er_emask.sen_ip_dst, 0, buf2, sizeof(buf2));
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "calling breakeroute and makeroute for %s->%s HOLD eroute.\n",
+					    buf1, buf2);
+			}
+#endif /* CONFIG_IPSEC_DEBUG */
+			if (!(ipsec_breakroute(&(hold_eroute.er_eaddr),
+						      &(hold_eroute.er_emask)) == EINVAL)) {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "breakeroute should have failed.\n");
+				/* SENDERR(-error); */
+			} else {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "HOLD breakeroute found nothing as expected.\n");
+			}
+			
+			if ((error = ipsec_makeroute(&(hold_eroute.er_eaddr),
+						     &(hold_eroute.er_emask),
+						     hold_said))) {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "HOLD makeroute returned %d, failed.\n", error);
+				/* SENDERR(-error); */
+			} else {
+				KLIPS_PRINT(debug_pfkey,
+					    "klips_debug:ipsec_tunnel_start_xmit: "
+					    "HOLD makeroute call successful.\n");
+			}
+			
 			goto cleanup;
-#endif
 		}
 		
 		/*
-		 * The spinlock is to prevent any other process from accessing or deleting
-		 * the tdb while we are using and updating it.
-		 */
-		spin_lock(&tdb_lock);
+		  The spinlock is to prevent any other process from
+		  accessing or deleting the TDB hash table or any of the
+		  TDBs while we are using and updating them.
+		  
+		  This is not optimal, but was relatively straightforward
+		  at the time.  A better way to do it has been planned for
+		  more than a year, to lock the hash table and put reference
+		  counts on each TDB instead.  This is not likely to happen
+		  in KLIPS1 unless a volunteer contributes it, but will be
+		  designed into KLIPS2.
+		*/
+		if(tdbprev == NULL) {
+			spin_lock(&tdb_lock);
+		}
 
 		tdbp = gettdb(&outgoing_said);
 		sa_len = satoa(outgoing_said, 0, sa, SATOA_BUF);
@@ -766,8 +873,8 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
-				    "no Tunnel Descriptor Block for SA%s: "
-				    "outgoing packet with no SA, dropped.\n", sa);
+				    "no Tunnel Descriptor Block for SA%s: outgoing packet with no SA, dropped.\n",
+				    sa_len ? sa : " (error)");
 			stats->tx_dropped++;
 			goto cleanup;
 		}
@@ -775,7 +882,8 @@
 		KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
 			    "found Tunnel Descriptor Block -- SA:<%s%s%s> %s\n",
-			    TDB_XFORM_NAME(tdbp), sa);
+			    TDB_XFORM_NAME(tdbp),
+			    sa_len ? sa : " (error)");
 		
 		/*
 		 * How much headroom do we need to be able to apply
@@ -789,9 +897,9 @@
 			if(tdbp->tdb_state == SADB_SASTATE_LARVAL) {
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "TDB in larval state for SA:<%s%s%s> %s, "
-					    "cannot be used yet, dropping packet.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "TDB in larval state for SA:<%s%s%s> %s, cannot be used yet, dropping packet.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
 				goto cleanup;
@@ -800,9 +908,9 @@
 			if(tdbp->tdb_state == SADB_SASTATE_DEAD) {
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "TDB in dead state for SA:<%s%s%s> %s, "
-					    "can no longer be used, dropping packet.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "TDB in dead state for SA:<%s%s%s> %s, can no longer be used, dropping packet.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
 				goto cleanup;
@@ -813,9 +921,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "replay window counter rolled for SA:<%s%s%s> %s, "
-					    "packet dropped, expiring SA.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "replay window counter rolled for SA:<%s%s%s> %s, packet dropped, expiring SA.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -828,9 +936,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard bytes lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard bytes lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -838,14 +946,15 @@
 			}
 			if(tdbp->tdb_lifetime_bytes_s &&
 			   (tdbp->tdb_lifetime_bytes_c > tdbp->tdb_lifetime_bytes_s)) {
-				pfkey_expire(tdbp, 0);
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+					pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft bytes lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft bytes lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			if(tdbp->tdb_lifetime_addtime_h &&
@@ -854,9 +963,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard addtime lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard addtime lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -865,14 +974,15 @@
 			if(tdbp->tdb_lifetime_addtime_s &&
 			   ((jiffies / HZ) - tdbp->tdb_lifetime_addtime_c >
 			    tdbp->tdb_lifetime_addtime_s)) {
-				pfkey_expire(tdbp, 0);
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+					pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft addtime lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft addtime lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			if(tdbp->tdb_lifetime_usetime_c) {
@@ -882,9 +992,9 @@
 					pfkey_expire(tdbp, 1);
 					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "hard usetime lifetime of SA:<%s%s%s> %s has been reached, "
-						    "SA expired, outgoing packet dropped.\n",
-						    TDB_XFORM_NAME(tdbp), sa);
+						    "hard usetime lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+						    TDB_XFORM_NAME(tdbp),
+						    sa_len ? sa : " (error)");
 					deltdbchain(tdbp);
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -893,14 +1003,15 @@
 				if(tdbp->tdb_lifetime_usetime_s &&
 				   ((jiffies / HZ) - tdbp->tdb_lifetime_usetime_c >
 				    tdbp->tdb_lifetime_usetime_s)) {
-					pfkey_expire(tdbp, 0);
+					if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+						pfkey_expire(tdbp, 0);
+					}
 					tdbp->tdb_state = SADB_SASTATE_DYING;
 					KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 						    "klips_debug:ipsec_tunnel_start_xmit: "
-						    "soft usetime lifetime of SA:<%s%s%s> %s has been reached, "
-						    "SA expiring, soft expire message sent up, "
-						    "outgoing packet still processed.\n",
-						    TDB_XFORM_NAME(tdbp), sa);
+						    "soft usetime lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+						    TDB_XFORM_NAME(tdbp),
+						    sa_len ? sa : " (error)");
 				}
 			}
 
@@ -909,9 +1020,9 @@
 				pfkey_expire(tdbp, 1);
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "hard packets lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expired, outgoing packet dropped.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "hard packets lifetime of SA:<%s%s%s> %s has been reached, SA expired, outgoing packet dropped.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 				deltdbchain(tdbp);
 				spin_unlock(&tdb_lock);
 				stats->tx_errors++;
@@ -919,21 +1030,23 @@
 			}
 			if(tdbp->tdb_lifetime_packets_s &&
 			   (tdbp->tdb_lifetime_packets_c > tdbp->tdb_lifetime_packets_s)) {
-				pfkey_expire(tdbp, 0);
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+					pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 					    "klips_debug:ipsec_tunnel_start_xmit: "
-					    "soft packets lifetime of SA:<%s%s%s> %s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "outgoing packet still processed.\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+					    "soft packets lifetime of SA:<%s%s%s> %s has been reached, SA expiring, soft expire message sent up, outgoing packet still processed.\n",
+					    TDB_XFORM_NAME(tdbp),
+					    sa_len ? sa : " (error)");
 			}
 
 			headroom = tailroom = 0;
 			KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "calling room for <%s%s%s>, SA:%s\n", 
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			switch(tdbp->tdb_said.proto) {
 #ifdef CONFIG_IPSEC_AH
 			case IPPROTO_AH:
@@ -1019,8 +1132,7 @@
 		
 		KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
 			    "klips_debug:ipsec_tunnel_start_xmit: "
-			    "existing head,tailroom: %d,%d "
-			    "before applying xforms with head,tailroom: %d,%d .\n",
+			    "existing head,tailroom: %d,%d before applying xforms with head,tailroom: %d,%d .\n",
 			    skb_headroom(skb), skb_tailroom(skb),
 			    max_headroom, max_tailroom);
 		
@@ -1030,8 +1142,8 @@
 		mtudiff = prv->mtu + tot_headroom + tot_tailroom - physmtu;
 
 		KLIPS_PRINT(debug_tunnel & DB_TN_CROUT,
-			    "klips_debug:ipsec_tunnel_start_xmit: mtu:%d physmtu:%d "
-			    "tothr:%d tottr:%d mtudiff:%d ippkttotlen:%d\n",
+			    "klips_debug:ipsec_tunnel_start_xmit: "
+			    "mtu:%d physmtu:%d tothr:%d tottr:%d mtudiff:%d ippkttotlen:%d\n",
 			    prv->mtu, physmtu,
 			    tot_headroom, tot_tailroom, mtudiff, ntohs(iph->tot_len));
 		if(mtudiff > 0) {
@@ -1065,7 +1177,8 @@
 			if (tcph->syn && !tcph->ack) {
 				if(!ipsec_adjust_mss(skb, tcph, prv->mtu)) {
 					spin_unlock(&tdb_lock);
-					printk(KERN_WARNING "klips: "
+					printk(KERN_WARNING
+					       "klips_warning:ipsec_tunnel_start_xmit: "
 					       "ipsec_adjust_mss() failed\n");
 					stats->tx_errors++;
 					goto cleanup;
@@ -1077,8 +1190,8 @@
 		if(!hard_header_stripped) {
 			if((saved_header = kmalloc(hard_header_len, GFP_ATOMIC)) == NULL) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: Failed, "
-				       "tried to allocate %d bytes for temp hard_header.\n", 
+				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: "
+				       "Failed, tried to allocate %d bytes for temp hard_header.\n", 
 				       hard_header_len);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1089,8 +1202,7 @@
 			if(skb->len < hard_header_len) {
 				spin_unlock(&tdb_lock);
 				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_pull hhlen=%d, %d available.  "
-				       "This should never happen, please report.\n",
+				       "tried to skb_pull hhlen=%d, %d available.  This should never happen, please report.\n",
 				       hard_header_len, (int)(skb->len));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1144,8 +1256,9 @@
 			skb = tskb;
 			if (!skb) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_debug:ipsec_tunnel_start_xmit: Failed, "
-				       "tried to allocate %d head and %d tailroom\n", 
+				printk(KERN_WARNING
+				       "klips_debug:ipsec_tunnel_start_xmit: "
+				       "Failed, tried to allocate %d head and %d tailroom\n", 
 				       max_headroom, max_tailroom);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1190,7 +1303,8 @@
 			KLIPS_PRINT(debug_tunnel & DB_TN_OXFS,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "calling output for <%s%s%s>, SA:%s\n", 
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			
 			switch(tdbp->tdb_said.proto) {
 #ifdef CONFIG_IPSEC_AH
@@ -1259,9 +1373,9 @@
 				    headroom, tailroom, tdbp->tdb_said.proto);
 			if(skb_headroom(skb) < headroom) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_push headroom=%d, %d available.  "
-				       "This should never happen, please report.\n",
+				printk(KERN_WARNING
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "tried to skb_push headroom=%d, %d available.  This should never happen, please report.\n",
 				       headroom, skb_headroom(skb));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1270,9 +1384,9 @@
 			ilen = skb->len - tailroom;
 			if(skb_tailroom(skb) < tailroom) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tried to skb_put %d, %d available.  "
-				       "This should never happen, please report.\n",
+				printk(KERN_WARNING
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "tried to skb_put %d, %d available.  This should never happen, please report.\n",
 				       tailroom, skb_tailroom(skb));
 				stats->tx_errors++;
 				goto cleanup;
@@ -1286,8 +1400,7 @@
 			if(len > 0xfff0) {
 				spin_unlock(&tdb_lock);
 				printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-				       "tot_len (%d) > 65520.  "
-				       "This should never happen, please report.\n",
+				       "tot_len (%d) > 65520.  This should never happen, please report.\n",
 				       len);
 				stats->tx_errors++;
 				goto cleanup;
@@ -1540,10 +1653,14 @@
 				/* XXX use of skb->dst below is a questionable
 				   substitute for &rt->u.dst which is only
 				   available later-on */
-				ip_select_ident(iph, skb->dst);
-#else
+#ifdef IP_SELECT_IDENT_NEW
+				ip_select_ident(iph, skb->dst, NULL);
+#else /* IP_SELECT_IDENT_NEW */
+                                ip_select_ident(iph, skb->dst);
+#endif /* IP_SELECT_IDENT_NEW */
+#else /* IP_SELECT_IDENT */
 				iph->id       = htons(ip_id_count++);   /* Race condition here? */
-#endif
+#endif /* IP_SELECT_IDENT */
 
 				newdst = (__u32)iph->daddr;
 				newsrc = (__u32)iph->saddr;
@@ -1559,7 +1676,7 @@
 					unsigned int flags = 0;
 #ifdef CONFIG_IPSEC_DEBUG
 					unsigned int old_tot_len = ntohs(iph->tot_len);
-#endif
+#endif /* CONFIG_IPSEC_DEBUG */
 					tdbp->tdb_comp_ratio_dbytes += ntohs(iph->tot_len);
 
 					skb = skb_compress(skb, tdbp, &flags);
@@ -1610,7 +1727,8 @@
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "after <%s%s%s>, SA:%s:\n",
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			KLIPS_IP_PRINT(debug_tunnel & DB_TN_XMIT, iph);
  			
 			tdbp->tdb_lifetime_bytes_c += len;
@@ -1620,6 +1738,7 @@
 			tdbp->tdb_lifetime_usetime_l = jiffies / HZ;
 			tdbp->tdb_lifetime_packets_c += 1;
 
+			tdbprev = tdbp;
 			tdbp = tdbp->tdb_onext;
 			
 		}
@@ -1640,7 +1759,8 @@
 			outgoing_said.dst.s_addr &&
 			er &&
 			(debug_tunnel & DB_TN_XMIT),
-			"klips_debug:ipsec_tunnel_start_xmit: We are recursing here.\n");
+			"klips_debug:ipsec_tunnel_start_xmit: "
+			"We are recursing here.\n");
 	} while(/*((orgdst != newdst) || (orgsrc != newsrc))*/
 		(orgedst != outgoing_said.dst.s_addr) &&
 		outgoing_said.dst.s_addr &&
@@ -1664,9 +1784,9 @@
 
 	if(saved_header) {
 		if(skb_headroom(skb) < hard_header_len) {
-			printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-			       "tried to skb_push hhlen=%d, %d available.  "
-			       "This should never happen, please report.\n",
+			printk(KERN_WARNING
+			       "klips_error:ipsec_tunnel_start_xmit: "
+			       "tried to skb_push hhlen=%d, %d available.  This should never happen, please report.\n",
 			       hard_header_len, skb_headroom(skb));
 			stats->tx_errors++;
 			goto cleanup;
@@ -1687,7 +1807,7 @@
 	skb->dev = physdev;
 	/*skb_orphan(skb);*/
 #ifdef NETDEV_23
-	if(sysctl_ipsec_no_eroute_pass) {
+	if(pass) {
 		/* zero the saddr used in ip_route_output */
 		route_saddr=0;
 	}else{
@@ -1719,9 +1839,9 @@
 	skb->dst = &rt->u.dst;
 	stats->tx_bytes += skb->len;
 	if(skb->len < skb->nh.raw - skb->data) {
-		printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-		       "tried to __skb_pull nh-data=%d, %d available.  "
-		       "This should never happen, please report.\n",
+		printk(KERN_WARNING
+		       "klips_error:ipsec_tunnel_start_xmit: "
+		       "tried to __skb_pull nh-data=%d, %d available.  This should never happen, please report.\n",
 		       skb->nh.raw - skb->data, skb->len);
 		stats->tx_errors++;
 		goto cleanup;
@@ -1746,7 +1866,8 @@
 		if(err != NET_XMIT_SUCCESS && err != NET_XMIT_CN) {
 			if(net_ratelimit())
 				printk(KERN_ERR
-				       "ipsec_tunnel_start_xmit: ip_send() failed, err=%d\n", 
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "ip_send() failed, err=%d\n", 
 				       -err);
 			stats->tx_errors++;
 			stats->tx_aborted_errors++;
